﻿Type=StaticCode
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Private Sub Process_Globals
End Sub

#Region UTILITY ROUTINES
'Get the timestamp from the json map and convert into format dd-MMM-YYYY HH:mm
'Need a loop as position of the key _timestamp changes when creating a new map
Public Sub GetTimeStamp(root As Map) As String
	Dim Result As String 
	Dim s As String
	For i = 0 To root.Size - 1
		s = root.GetKeyAt(i) 
		If s.EqualsIgnoreCase("_timestamp") Then
			Dim TimeStamp As Long = root.GetValueAt(i) * 1000
			'Set the dateformat
			DateTime.DateFormat = "dd-MMM-YYYY"
			DateTime.TimeFormat = "HH:mm"
			'Convert Date & Time to string
			Result = DateTime.Date(TimeStamp) & " " & DateTime.Time(TimeStamp)
		End If
	Next
	Return Result
End Sub

'Get the timestamp from the json map and convert into format dd-MMM-YYYY HH:mm
Public Sub ConvertUnixTimeStamp(TimeStamp As Long) As String
	TimeStamp = TimeStamp * 1000
	DateTime.DateFormat = "dd-MMM-YYYY"
	DateTime.TimeFormat = "HH:mm"
	'Convert Date & Time to string
	Return DateTime.Date(TimeStamp) & " " & DateTime.Time(TimeStamp)
End Sub

'Fill a string with blanks up to len chars
'This is being used for the LCD20x4 line as having 20chars to fill
Public Sub FillStr(s As String, c As Char, len As Int) As String
	Try
		For i = s.Length To len - 1
			s = s & c
		Next
	Catch
		Log(LastException)
	End Try
	Return s
End Sub

'Insert a string at position. Min position > 0, Max position = string length + 1
'Example: Dim s As String = "Hello World", Log(InsertStr(s, "My ", 7))
Public Sub InsertStr(s As String, sinsert As String, pos As Int) As String
	Dim Result As String
	Try
		Result = s.SubString2(0,pos - 1) & sinsert & s.SubString2(pos - 1, s.Length)
	Catch
		Log(LastException)
	End Try
	Return Result
End Sub
#End Region

Public Sub EscapeURL(Raw As String) As String
   Dim sb As StringBuilder
   sb.Initialize
   For i = 0 To Raw.Length - 1
     Dim C As Char = Raw.CharAt(i)
	 Select C
       Case CRLF
         sb.Append("%0A")
         'sb.Append("%0A%0D")
		Case Chr(0)
         	sb.Append("%20")
		Case Chr(32)
         	sb.Append("%20")
		Case "!" 	
			sb.Append("%21")
		Case """"
			sb.Append("%22")
		Case "#" 	
			sb.Append("%23")
		Case "$" 	
			sb.Append("%24")
		Case "%" 	
			sb.Append("%25")
		Case "&" 	
			sb.Append("%26")
		Case "'" 	
			sb.Append("%27")
		Case "(" 	
			sb.Append("%28")
		Case ")" 	
			sb.Append("%29")
		Case "*" 	
			sb.Append("%2A")
		Case "+" 	
			sb.Append("%2B")
		Case "," 	
			sb.Append("%2C")
		Case "/" 	
			sb.Append("%2F")
		Case ":" 	
			sb.Append("%3A")
		Case ";" 	
			sb.Append("%3B")
		Case "=" 	
			sb.Append("%3D")
		Case "?" 	
			sb.Append("%3F")
		Case "@" 	
			sb.Append("%40")
		Case "[" 	
			sb.Append("%5B")
		Case "]" 	
			sb.Append("%5D")
		Case "<"
			sb.Append("%3C")
		Case ">"
			sb.Append("%3E")
		 Case "-"
			sb.Append("%20")

		' UMLAUTE
		Case "Ä"
			sb.Append("%C3%84")
		Case "ä"
			sb.Append("%C3%A4")
		Case "Ö"
			sb.Append("%C3%96")
		Case "ö"
			sb.Append("%C3%B6")
		Case "Ü"
			sb.Append("%C3%9C")
		Case "ü"
			sb.Append("%C3%BC")
		Case "ß"
			sb.Append("%C3%9F")
       	Case Else
         	sb.Append(C)
     End Select
   Next
   Return sb.ToString
End Sub

'Get the actual date and time and return as string. Make changes to the format here.
Public Sub GetDateTime As String
	DateTime.DateFormat = "dd-MMM-yyyy HH:mm"
	Return DateTime.Date(DateTime.Now)
End Sub

'Delay 
Public Sub Delay(DurationMs As Int)
 Dim target As Long = DateTime.Now + DurationMs
 Do While DateTime.Now < target
 Loop
End Sub
